// • ▌ ▄ ·.  ▄▄▄·  ▄▄ • ▪   ▄▄· ▄▄▄▄·  ▄▄▄·  ▐▄▄▄  ▄▄▄ .
// ·██ ▐███▪▐█ ▀█ ▐█ ▀ ▪██ ▐█ ▌▪▐█ ▀█▪▐█ ▀█ •█▌ ▐█▐▌·
// ▐█ ▌▐▌▐█·▄█▀▀█ ▄█ ▀█▄▐█·██ ▄▄▐█▀▀█▄▄█▀▀█ ▐█▐ ▐▌▐▀▀▀
// ██ ██▌▐█▌▐█ ▪▐▌▐█▄▪▐█▐█▌▐███▌██▄▪▐█▐█ ▪▐▌██▐ █▌▐█▄▄▌
// ▀▀  █▪▀▀▀ ▀  ▀ ·▀▀▀▀ ▀▀▀·▀▀▀ ·▀▀▀▀  ▀  ▀ ▀▀  █▪ ▀▀▀
//      Magicbane Emulator Project © 2013 - 2022
//                www.magicbane.com


package engine.db.handlers;

import engine.gameManager.DbManager;
import engine.gameManager.PowersManager;
import engine.mbEnums;
import engine.objects.EffectsResourceCosts;
import org.json.JSONObject;
import org.pmw.tinylog.Logger;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;

public class dbEffectsResourceCostHandler extends dbHandlerBase {

    public dbEffectsResourceCostHandler() {
        this.localClass = EffectsResourceCosts.class;
        this.localObjectType = mbEnums.GameObjectType.valueOf(this.localClass.getSimpleName());
    }

    public void LOAD_ALL_COSTMAPS() {

        try (Connection connection = DbManager.getConnection();
             PreparedStatement preparedStatement = connection.prepareStatement("SELECT * FROM `static_effect_costmaps`")) {

            ResultSet rs = preparedStatement.executeQuery();

            while (rs.next()) {
                String effectID = rs.getString("effectID");
                String costString = rs.getString("costmap");
                JSONObject costJSON = new JSONObject(costString);
                HashMap<mbEnums.ResourceType, Integer> costmap = new HashMap<>();

                for (String key : costJSON.keySet()) {
                    int value = costJSON.getInt(key);
                    costmap.put(mbEnums.ResourceType.valueOf(key), value);
                }

                PowersManager._effect_costMaps.put(effectID, costmap);
            }

        } catch (SQLException e) {
            Logger.error(e);
        }
    }

}
